<template>
  <div class="brandManagement">
    <div class="el-card__header">
      <span>品牌列表</span>
      <div style="display: flex; flex-direction: row; align-items: center" v-if="!readonly">
        <el-button type="primary" class="el-button--small" @click="addTopic">新增</el-button>
        <el-button class="el-button--small" @click="dialogVisible = true,checkAll=false" style="float: right"
          type="primary">批量导出
        </el-button>
      </div>
    </div>
    <div class="content" v-if="!readonly">
      <div style="display: flex; flex-direction: row; align-items: center">
        <div class="block">
          <span style="margin-left: 10px">品牌名</span>
          <el-input @keyup.enter.native="(msg.pageIndex = 1), getList()" @clear="(msg.pageIndex = 1), getList()"
            style="display: inline-block; width: 225px; height: 30px" placeholder="请输入品牌名" v-model="msg.BrandName"
            size="small" clearable>
          </el-input>
          <span style="margin-left: 10px">商铺区域</span>
          <el-select class="w100" @change="(msg.pageIndex = 1), getList()" style="margin-left: 10px"
            v-model="msg.ProjectType" size="small" placeholder="请选择商铺区域" filterable>
            <el-option label="不限" :value="0"></el-option>
            <el-option :label="x.Name" :value="x.Id" v-for="(x, y) in ProjectTypeList" :key="y"></el-option>
          </el-select>
          <span style="margin-left: 10px">品牌分类</span>
          <el-cascader   style="margin-left: 10px" v-model="msg.BrandClassId" size="small" placeholder="请选择"
            :options="BrandClassTree" :props="{checkStrictly: true, emitPath: false}" filterable
            @change="(msg.pageIndex = 1), getList()">
          </el-cascader>
          <span style="margin-left: 10px">认证用户</span>
          <el-select size="small" v-model="msg.UserId" :filter-method="ChangeListName" filterable
            @change="(msg.pageIndex = 1), getList()" placeholder="请选择">
            <el-option label="不限" :value="0"></el-option>
            <el-option v-for="item in userList" :key="item.Id" :label="item.Name" :value="item.Id">
            </el-option>
          </el-select>
        </div>
      </div>
      <div style="
          display: flex;
          flex-direction: row;
          align-items: center;
          flex-wrap: wrap;
        ">
        <div class="block" style="margin-top: 15px; margin-left: 10px">
          <span>上下水</span>
          <el-select class="w100" @change="(msg.pageIndex = 1), getList()" style="margin-left: 5px"
            v-model="msg.Plumbing" size="small" placeholder="请选择">
            <el-option label="不限" :value="-1"></el-option>
            <el-option label="是" :value="1"></el-option>
            <el-option label="否" :value="0"></el-option>
          </el-select>
        </div>
        <div class="block" style="margin-top: 15px; margin-left: 10px">
          <span>管径</span>
          <el-select class="w100" @change="(msg.pageIndex = 1), getList()" style="margin-left: 5px"
            v-model="msg.Caliber" size="small" placeholder="请选择">
            <el-option label="不限" :value="-1"></el-option>
            <el-option label="是" :value="1"></el-option>
            <el-option label="否" :value="0"></el-option>
          </el-select>
        </div>
        <div class="block" style="margin-top: 15px; margin-left: 10px">
          <span>排污</span>
          <el-select class="w100" @change="(msg.pageIndex = 1), getList()" style="margin-left: 5px" v-model="msg.Sewage"
            size="small" placeholder="请选择">
            <el-option label="不限" :value="-1"></el-option>
            <el-option label="是" :value="1"></el-option>
            <el-option label="否" :value="0"></el-option>
          </el-select>
        </div>
        <div class="block" style="margin-top: 15px; margin-left: 10px">
          <span>燃气</span>
          <el-select class="w100" @change="(msg.pageIndex = 1), getList()" style="margin-left: 5px" v-model="msg.RanQi"
            size="small" placeholder="请选择">
            <el-option label="不限" :value="-1"></el-option>
            <el-option label="是" :value="1"></el-option>
            <el-option label="否" :value="0"></el-option>
          </el-select>
        </div>
        <div class="block" style="margin-top: 15px; margin-left: 10px">
          <span>排烟量</span>
          <el-select class="w100" @change="(msg.pageIndex = 1), getList()" style="margin-left: 5px" v-model="msg.PaiYan"
            size="small" placeholder="请选择">
            <el-option label="不限" :value="-1"></el-option>
            <el-option label="是" :value="1"></el-option>
            <el-option label="否" :value="0"></el-option>
          </el-select>
        </div>
        <div class="block" style="margin-top: 15px; margin-left: 10px">
          <span>空调</span>
          <el-select class="w100" @change="(msg.pageIndex = 1), getList()" style="margin-left: 5px"
            v-model="msg.KongTiao" size="small" placeholder="请选择">
            <el-option label="不限" :value="-1"></el-option>
            <el-option label="是" :value="1"></el-option>
            <el-option label="否" :value="0"></el-option>
          </el-select>
        </div>
        <div class="block" style="margin-top: 15px; margin-left: 10px">
          <span>新风</span>
          <el-select class="w100" @change="(msg.pageIndex = 1), getList()" style="margin-left: 5px"
            v-model="msg.XinFeng" size="small" placeholder="请选择">
            <el-option label="不限" :value="-1"></el-option>
            <el-option label="是" :value="1"></el-option>
            <el-option label="否" :value="0"></el-option>
          </el-select>
        </div>
        <div class="block" style="margin-top: 15px; margin-left: 10px">
          <span>成都落地</span>
          <el-select class="w100" @change="(msg.pageIndex = 1), getList()" style="margin-left: 5px"
            v-model="msg.IsInChengdu" size="small" placeholder="请选择">
            <el-option label="不限" :value="-1"></el-option>
            <el-option label="是" :value="1"></el-option>
            <!-- <el-option label="否" :value="0"></el-option> -->
          </el-select>
        </div>

      </div>
    </div>
    <div style="padding: 20px; background: #fff">
      <el-table :data="dataList" header-cell-class-name="headClass" style="width: 100%"  height="540" border>
        <el-table-column prop="Id" label="ID" width="70">
          <template slot-scope="scope">
            <span @click="goRecruit(scope.row.ID)">{{ scope.row.ID }}</span>
          </template>
        </el-table-column>
        <el-table-column prop="BrandClassList" label="分类" width="100">
          <template slot-scope="scope">
            <template v-if="scope.row.BrandClassList&&scope.row.BrandClassList.length>0">
              <el-tag v-for="(tagItem,tagIndex) in scope.row.BrandClassList" :key="tagIndex">
                {{ tagItem.Name }}
              </el-tag>
            </template>
          </template>
        </el-table-column>
        <el-table-column prop="BrandName" label="品牌"> </el-table-column>
        <el-table-column prop="Logo" label="Logo" width="100">
          <template slot-scope="scope">
            <el-image v-if="scope.row.Logo" :src="scope.row.Logo" style="width: 50px"
              :preview-src-list="scope.row.LogoList">
            </el-image>
          </template>
        </el-table-column>
        <el-table-column prop="ShopNum" label="店铺数量" width="80">
        </el-table-column>
        <el-table-column prop="BuiltUpArea" label="建筑面积" width="120">
          <template slot-scope="scope">
            <span>{{ scope.row.BuiltUpArea }} 至
              {{ scope.row.EndBuiltUpArea }} 平</span>
          </template>
        </el-table-column>
        <el-table-column prop="ProjectName" label="商铺区域" width="150">
        </el-table-column>
        <el-table-column prop="BrandType" label="品牌定位" width="180">
        </el-table-column>
        <el-table-column prop="CustomerType" label="客群定位" width="160">
        </el-table-column>
        <el-table-column prop="ContactName" label="联系人" width="120">
          <template slot-scope="scope">
            {{  scope.row.ContactName }}
            <br />
            {{  scope.row.ContactPhone }}
          </template>
        </el-table-column>
        <el-table-column prop="UserName" width="100" label="认证用户"></el-table-column>
        <el-table-column prop="IsRecommend" width="110" label="推荐" >
          <template slot-scope="scope">
            <el-switch v-model="scope.row.IsRecommend" :active-value="1" :inactive-value="0"
              @change="changeRecommend(scope.row, $event)">
            </el-switch>
          </template>
        </el-table-column>
        <el-table-column fixed="right" label="操作" width="120">
          <template slot-scope="scope" v-if="!readonly">
            <el-tooltip class="item" effect="dark" content="编辑" placement="top">
              <img src="../../assets/img/setup/edit.png" alt="" class="imgstyle" @click="Edit(scope.row)" />
            </el-tooltip>
            <el-tooltip class="item" effect="dark" content="删除" placement="top">
              <img src="../../assets/img/setup/del.png" alt="" class="imgstyle" @click="delete_b(scope.row)" />
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination style="text-align: right" background @current-change="handleCurrentChange"
        :page-size="msg.pageSize" layout="total, prev, pager, next" :current-page.sync="msg.pageIndex"
        :total="pageCount">
      </el-pagination>
    </div>

    <!-- 选择导出信息 -->
    <el-dialog title="选择导出信息" :visible.sync="dialogVisible" width="960px">
      <div v-loading="downLoadLoading" :element-loading-text="loadingText">
        <el-form style="border: 1px solid #f0f2f7" :model="addMsg" ref="addMsg" label-width="100px">
          <div style="
            box-sizing: border-box;
            background-color: #f3f5f6;
            width: 100%;
            padding-left: 20px;
            height: 50px;
            line-height: 50px;
          ">
            <el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange">全选
            </el-checkbox>
          </div>
          <div style="margin: 15px 0"></div>
          <div style="padding: 10px 25px 20px">
            <el-checkbox-group v-model="checkedCities" @change="handleCheckedCitiesChange">
              <el-checkbox style="margin-bottom: 10px; width: 135px" v-for="city in cities" :label="city.Id"
                :key="city.Name">
                {{ city.Name }}</el-checkbox>
            </el-checkbox-group>
          </div>
        </el-form>
        <div style="text-align: right; margin-top: 20px">
          <el-button size="small" type="primary" @click="downloadBrandFile">导出</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>
<script>
  import {
    setInterval,
    clearInterval
  } from 'timers';
  export default {
    name: "brandManagement",
    data() {
      return {
        msg: {
          pageIndex: 1,
          pageSize: 20,
          BrandName: "", //品牌名
          ProjectType: 0, //商铺性质
          Plumbing: -1, //上下水（0-否1-有）
          Caliber: -1, //管径（0-否1-有）
          Sewage: -1, //排污（0-否1-有）
          RanQi: -1, //燃气（0-否1-有）
          DianLiang: "", //电量（0-否1-有）
          PaiYan: -1, //排烟量（0-否1-有）
          KongTiao: -1, //空调（0-否1-有）
          XinFeng: -1, //新风（0-否1-有）
          IsInChengdu: -1, //成都落地
          BrandClassId: 0, //分类
          ExcelEnumIds: [],
          UserId: 0, //用户认证
          PrizeId: 0,
          RandomNum: 0, //随机数
        },
        usermsg: {
          pageIndex: 1,
          pageSize: 20,
          Name: "",
          Source: 0,
          MemberGrade: 0,
          Id: 0,
          Moblie: "",
        },
        userList: [],
        addMsg: {},
        dialogVisible: false,
        dataList: [],
        checkAll: false,
        checkedCities: [],
        cities: [],
        cityOptions: [],
        isIndeterminate: false,
        pageCount: 0,
        loading: false,
        BrandClassTree: [], //品牌分类列表
        ProjectTypeList: [], //商铺性质列表
        readonly: false,
        downLoadLoading: false, //导出Loading
        download_timer: null, //下载文件timer
        loadingText: "", //下载文件提示名称
      };
    },
    created() {
      if (this.$route.query && this.$route.query.UserId) {
        this.msg.UserId = Number(this.$route.query.UserId);
        this.usermsg.Id = Number(this.$route.query.UserId);
        this.getuserList(1);
      } else {
        this.getuserList();
      }
      this.getBrandClassTree();
      this.getProjectType();
      this.getDown();
    },
    mounted() {
      if (this.$route.query && this.$route.query.readonly) {
        this.readonly = this.$route.query.readonly;
      }
      if (this.$route.query && this.$route.query.PrizeId) {
        this.msg.PrizeId = this.$route.query.PrizeId;
      }

      this.getList();
    },
    methods: {
      ChangeListName(val) {
        this.usermsg.Name = val;
        this.getuserList();
      },
      getuserList(type = 0) {
        this.apipost(
          "/api/user/GetMemberUserDropDownList",
          this.usermsg,
          (res) => {
            if (res.data.resultCode == 1) {
              let pageData = res.data.data.pageData;
              this.userList = pageData;
              if (type == 1) {
                this.usermsg.Id = 0;
              }
            }
          }
        );
      },
      //下载品牌文件
      downloadBrandFile() {
        this.msg.ExcelEnumIds = this.checkedCities;
        let msg = JSON.parse(JSON.stringify(this.msg));
        msg.RandomNum = Math.random();
        if (!msg.Id || msg.Id == "") {
          msg.Id = 0;
        }
        this.downLoadLoading = true;
        this.loadingText = "正在生成品牌文件,请勿关闭或刷新页面...";
        var that = this;
        this.download_timer = setInterval(function () {
          that.checkFile(msg)
        }, 2000);
      },
      checkFile(msg) {
        var fileName = "品牌信息.xls";
        var that = this;
        this.apipost(
          "/api/Trade/CheckBrandFile",
          msg,
          (res) => {
            if (res.data.resultCode == 1) {
              clearInterval(this.download_timer);
              this.checkedCities = [];
              this.loadingText = "正在下载品牌文件,请勿关闭或刷新页面...";
              var fileUrl = res.data.data.fileUrl;
              var filepath = res.data.data.filePath;
              var key = res.data.message;
              var params = {
                fileUrl: fileUrl
              }
              //删除缓存和Key
              var deleteparams = {
                key: key,
                fileUrl: fileUrl,
                filepath: filepath,
              };
              var apiurl = that.domainManager().DomainUrl + "/api/Trade/GetFile";
              var postData = that.GetPostData("", params, "");
              that.$http.post(apiurl, postData, {
                responseType: 'arraybuffer',
                onDownloadProgress: (progressEvent) => {
                  const progress = Math.round((progressEvent.loaded / progressEvent.total) * 100);
                  that.loadingText = `正在下载品牌文件` + progress + `%,请勿关闭或刷新页面...`;
                  // 在这里处理下载进度, 如更新界面上的进度条
                }
              }).then((res) => {
                let blob = new Blob([res.data], {
                  type: "application/vnd.ms-excel"
                })
                let url = URL.createObjectURL(blob);
                let link = document.createElement('a');
                link.href = url;
                link.setAttribute("download", fileName);
                document.body.appendChild(link);
                link.click();
                that.downLoadLoading = false;
                that.loadingText = "";
                that.apipost("/api/Trade/DeleteKey", deleteparams, (res) => {})
                that.dialogVisible = false;
              }).catch(function (res) {
                console.log(res);
              });
            }
          }
        );
      },
      getDown() {
        this.cityOptions = [];
        this.apipost("/api/Trade/GetBusinessExportEnumList", {}, (res) => {
          var tempData = [];
          let data = res.data.data;
          data.forEach((item) => {
            this.cityOptions.push(item.Id);
            tempData.push(item);
          });
          this.cities = tempData;
        });
      },
      //获取商铺性质
      getProjectType() {
        this.apipost("/api/Trade/GetProjectTypeEnumList", {}, (res) => {
          if (res.data.resultCode == 1) {
            this.ProjectTypeList = res.data.data;
          } else {
            this.Error(res.data.message);
          }
        });
      },
      handleCheckAllChange(val) {
        this.checkedCities = val ? this.cityOptions : [];
        this.isIndeterminate = false;
      },
      handleCheckedCitiesChange(value) {
        let checkedCount = value.length;
        this.checkAll = checkedCount === this.cities.length;
        this.isIndeterminate =
          checkedCount > 0 && checkedCount < this.cities.length;
      },
      getList() {
        this.apipost("/api/Trade/GetBrandPageList", this.msg, (res) => {
          if (res.data.resultCode == 1) {
            this.dataList = res.data.data.pageData;
            this.pageCount = res.data.data.count;
            this.dataList.forEach((x) => {
              x.LogoList = [];
              x.LogoList.push(x.Logo);
            });
          } else {
            this.Error(res.data.message);
          }
        });
      },
      getBrandClassTree() {
        this.apipost("/api/Trade/GetBrandClassTree", {
          BrandCategory: 3
        }, (res) => {
          if (res.data.resultCode == 1) {
            this.BrandClassTree = res.data.data;
          } else {
            this.Error(res.data.message);
          }
        });
      },
      handleCurrentChange(val) {
        this.msg.pageIndex = val;
        this.getList();
      },
      //新增品牌
      addTopic() {
        this.$router.push("/addbrand");
      },
      //删除品牌
      delete_b(row) {
        let that = this;
        that.Confirm("是否删除?", function () {
          that.apipost(
            "/api/Trade/RemoveBrand", {
              Id: row.ID,
            },
            (res) => {
              if (res.data.resultCode == 1) {
                that.Success(res.data.message);
                that.getList();
              } else {
                that.Error(res.data.message);
              }
            }
          );
        });
      },
      //编辑数据
      Edit(row) {
        this.$router.push({
          name: "addbrand",
          query: {
            ID: row.ID,
            blank: "y",
          },
        });
      },
      //切换
      changeSwitch(item) {
        let msg = {
          Id: item.Id,
          IsOpen: item.IsOpen,
        };
        this.apipost("/api/Education/UpdateEducationTalkShow", msg, (res) => {
          if (res.data.resultCode == 1) {
            this.Success(res.data.message);
            this.getList();
          }
        });
      },
      //推荐/取消推荐
      changeRecommend(row, val) {
        let msg = {
          Id: row.ID,
          IsRecommend: val,
        };
        this.apipost("/api/Trade/RecommendBrand", msg, (res) => {
          if (res.data.resultCode == 1) {
            this.Success(res.data.message);
            this.getList();
          } else {
            this.Error(res.data.message);
          }
        });
      },
    },
  };

</script>

<style>
  .brandManagement .el-card__header {
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: space-between;
    background: #fff;
  }

  .brandManagement .content {
    background: #fff;
    margin-top: 10px;
    padding: 15px;
    box-sizing: border-box;
  }

</style>
